<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>HW-4(AJAX)</title>
</head>

<body>

    <!-- AJAX - асинхронный запрос джава скрипт на сервер для получения необходимой(запрашиваемой) информации с целью ее
    последующей обработки и использования. -->


    <div id="wrapper">
        <h1>"Star Wars"</h1>
    </div>


    <style>
        body {
            background-color: black;
            color: blanchedalmond;
        }

        h1 {
            font-size: 4rem;
            text-align: center;
            text-transform: uppercase;
        }

        #wrapper {
            max-width: 70%;
            display: flex;
            flex-direction: column;
            margin-left: 6%;
        }

        .title {
            padding-top:1rem;
            margin-top: 2rem;
            color: white;
            font-size: 2rem;
            text-transform: uppercase;
            font-weight: bold;
            border-top: 2px solid white;;

        }

        .h2 {
            color: whitesmoke;
            font-size: 1.5rem;
        }
    </style>

    <script>

        fetch('https://swapi.dev/api/films')
            .then((resp) => resp.json())
            .then((answer) => {
                handlePromis(answer)
            })
            .catch((error) => {
                throw new Error(error.message);
            });

        // -------------------------------------------------------------------

        function handlePromis(answer) {
            let { results } = answer;
            const list = createList();
            for (let obj of results) {
                createNode(list, obj);
            }
        }
        // ----------------------------------------------------------------------------------
        function createNode(parent, { title, episode_id, opening_crawl, characters }) {
            let film = document.createElement('li');
            film.classList.add('film');
            let titleFilm = document.createElement('h2');
            titleFilm.classList.add('title');
            titleFilm.textContent = title;
            let episodNumber = document.createElement('span');
            episodNumber.classList.add('episodNumber');
            episodNumber.textContent = ' (№ ' + episode_id + ')';
            titleFilm.append(episodNumber);

            let description = document.createElement('p');
            description.classList.add('description');
            description.textContent = opening_crawl;
            let h2 = document.createElement('h2');
            h2.classList.add('h2');
            h2.textContent = 'Characters in this Episod:';
            let charactersInEpisod = document.createElement('p');
            charactersInEpisod.classList.add('characters');
            let text = '';
            for (let linkItem of characters) {
                fetch(linkItem)
                    .then((response) => response.json())
                    .then((object) => {
                        charactersInEpisod.textContent += object.name + '... ';
                    })
                    .catch((error) => {
                        throw new Error(error.message);
                    });

            }

            film.append(titleFilm);
            film.append(description);
            film.append(h2);
            film.append(charactersInEpisod);
            parent.append(film);
        };
        // --------------------------------------------------------------------------------
        function createList() {
            const wrapper = document.getElementById('wrapper');
            const list = document.createElement('ul');
            list.classList.add('filmList');
            wrapper.append(list);
            return list;
        }




    </script>
</body>

</html>